//
// templates.cc
//
// $Id: templates.cc,v 1.1.1.1 2001/02/28 00:28:38 cstolte Exp $
//

#include <sgl/matrix.h>
#include "matrix.cc"

template Mat<5, double> operator*(double, const Mat<5, double> &);
template Mat<4, double> operator*(double, const Mat<4, double> &);
template Mat<3, double> operator*(double, const Mat<3, double> &);
template Mat<2, double> operator*(double, const Mat<2, double> &);
template Mat<1, double> operator*(double, const Mat<1, double> &);

template Vec<5, double> operator*(const Vec<5, double> &, const Mat<5, double> &);
template Vec<4, double> operator*(const Vec<4, double> &, const Mat<4, double> &);
template Vec<3, double> operator*(const Vec<3, double> &, const Mat<3, double> &);
template Vec<2, double> operator*(const Vec<2, double> &, const Mat<2, double> &);
template Vec<1, double> operator*(const Vec<1, double> &, const Mat<1, double> &);

template std::ostream &operator<<(std::ostream &, const Vec<1,double> &);
template std::ostream &operator<<(std::ostream &, const Vec<2,double> &);
template std::ostream &operator<<(std::ostream &, const Vec<3,double> &);
template std::ostream &operator<<(std::ostream &, const Vec<4,double> &);
template std::ostream &operator<<(std::ostream &, const Vec<5,double> &);

template std::ostream &operator<<(std::ostream &, const Mat<1,double> &);
template std::ostream &operator<<(std::ostream &, const Mat<2,double> &);
template std::ostream &operator<<(std::ostream &, const Mat<3,double> &);
template std::ostream &operator<<(std::ostream &, const Mat<4,double> &);
template std::ostream &operator<<(std::ostream &, const Mat<5,double> &);

template double dot(const Vec<1, double> &, const Vec<1, double> &);
template double dot(const Vec<2, double> &, const Vec<2, double> &);
template double dot(const Vec<3, double> &, const Vec<3, double> &);
template double dot(const Vec<4, double> &, const Vec<4, double> &);
template double dot(const Vec<5, double> &, const Vec<5, double> &);

template Vec<1, double> MIN(const Vec<1, double> &, const Vec<1, double> &);
template Vec<2, double> MIN(const Vec<2, double> &, const Vec<2, double> &);
template Vec<3, double> MIN(const Vec<3, double> &, const Vec<3, double> &);
template Vec<4, double> MIN(const Vec<4, double> &, const Vec<4, double> &);
template Vec<5, double> MIN(const Vec<5, double> &, const Vec<5, double> &);

template Vec<1, double> MAX(const Vec<1, double> &, const Vec<1, double> &);
template Vec<2, double> MAX(const Vec<2, double> &, const Vec<2, double> &);
template Vec<3, double> MAX(const Vec<3, double> &, const Vec<3, double> &);
template Vec<4, double> MAX(const Vec<4, double> &, const Vec<4, double> &);
template Vec<5, double> MAX(const Vec<5, double> &, const Vec<5, double> &);

template Vec<1, double> reflection(const Vec<1, double> &, const Vec<1, double> &);
template Vec<2, double> reflection(const Vec<2, double> &, const Vec<2, double> &);
template Vec<3, double> reflection(const Vec<3, double> &, const Vec<3, double> &);
template Vec<4, double> reflection(const Vec<4, double> &, const Vec<4, double> &);
template Vec<5, double> reflection(const Vec<5, double> &, const Vec<5, double> &);

template bool refraction(const Vec<1, double> &, const Vec<1, double> &, 
			 Vec<1, double> *, double, double);
template bool refraction(const Vec<2, double> &, const Vec<2, double> &, 
			 Vec<2, double> *, double, double);
template bool refraction(const Vec<3, double> &, const Vec<3, double> &, 
			 Vec<3, double> *, double, double);
template bool refraction(const Vec<4, double> &, const Vec<4, double> &, 
			 Vec<4, double> *, double, double);
template bool refraction(const Vec<5, double> &, const Vec<5, double> &, 
			 Vec<5, double> *, double, double);

template class Vec<5, double>;
template class Vec<4, double>;
template class Vec<3, double>;
template class Vec<2, double>;
template class Vec<1, double>;

template class Mat<5, double>;
template class Mat<4, double>;
template class Mat<3, double>;
template class Mat<2, double>;
template class Mat<1, double>;
