//
// testwnoise.cc
//
// $Id: testwnoise.cc,v 1.1.1.1 2001/02/28 00:28:39 cstolte Exp $
//

#include <sgl/wnoise.h>
#include <sgl/mathfunc.h>
#include <stdio.h>

extern bool sgl_wnoise_exhaustive;

int main()
{
    int size = 512;
    double offset = -5;
    double extent = double(size)/25.;

    FILE *f = fopen("out.ppm", "w");
    fprintf(f, "P6\n%d %d 255\n", size, size);

    for (int i = 0; i < size; ++i)
	for (int j = 0; j < size; ++j) {
	    double u = 0.001;

	    double v = offset + (double)i / extent;
	    double w = offset + (double)j / extent;

	    sgl_wnoise_exhaustive = false;
	    double val;
//CO	    if (v < 0. || w < 0.)
		val = wNoise1(Tuple3d(u, v, w));
//CO	    else
//CO		val = 0;

	    val = clamp(fabs(val), 0., 1.);

#if 1
	    sgl_wnoise_exhaustive = true;
	    double val2 = wNoise1(Tuple3d(u, v, w));
	    val2 = clamp(fabs(val2), 0., 1.);
	    
	    if (val2 != val) {
		cerr << v << " " << w << '\t' << val << '\t' << val2 << endl;
		sgl_wnoise_exhaustive = false;
		wNoise1(Tuple3d(u, v, w));
	    }
#endif
	    u_char r, g, b;
	    r = g = b = 255 * val;

	    fprintf(f, "%c%c%c", r, g, b);
	}

    return 0;
}
