function retdata=loadascii(filename)
%LOADASCII - load an ascii numerical table into matlab
%
%  function retdata=loadascii(filename)
%
%  load is not supported by the matlab compiler, so 
%  we need a new function to load tables
%
%  jed 7/2002

% Open the file
fid = fopen(filename,'r');
if (fid== -1)
     disp(['File does not exist: ',filename]);
     return;
end

% Get the first line
line1 = fgets(fid);

% Parse the first line
[line1data,columns]=sscanf(line1,'%f ');

% Get the rest of the file
remainingData=fscanf(fid,'%f ');

% Close file
fclose(fid);

% Reshape the rest of the file
data=[line1data;remainingData];
rows=length(data)/columns;
if (rows ~= round(rows))
     disp('File does not contain an even number of rows');
     return;
end
retdata=reshape(data,columns,rows);
retdata=retdata';
