function xyzuvcal(xyzuvname,intrname,finname)
% XYZUVCAL - calibrate a camera from xyzuv data
%
%   function xyzuvcal(xyzuvname,intrname,finname)
% 
%   A wrapper function on XYZUVCAL_EXTONLY and XYZUVCAL_BOTH
%   We check for existance of intrname, and call the 
%   appropriate function.
%
%    xyzuvname - the input xyzuv data file
%    intrname  - the name of a file with internal camera parameters
%    finname   - the output fin file
%
%   JED 11/00

% Check for blank string
% Check for existance of file
if (~isempty(intrname) &  exist(intrname)==2)
  % Call the right function
  xyzuvcal_extonly(xyzuvname,intrname,finname);
  disp (' ');
  disp ('---------------------------------------------------------------');
  disp ('Calibrated external parameters only.');
  disp ('---------------------------------------------------------------');
  disp (' ');
else
  xyzuvcal_both(xyzuvname,finname);
  disp (' ');
  disp ('---------------------------------------------------------------');
  disp ('Calibrated both internal and external parameters.');
  disp ('---------------------------------------------------------------');
  disp (' ');
end
