/*
houghmain.cc

Original by aroetter, hacked by smr
*/

#include <stdio.h>
#include "hough.h"
#include "colorconversion.h"

int main(int argc, char **argv)
{
	ios::sync_with_stdio(); 
	
	if (argc < 7) {
		fprintf(stderr, "Usage: %s rows cols R dR graythresh file.rgb [channel]\n", argv[0]);
		exit(1);
	}

	int rows = atoi(argv[1]);
	int cols = atoi(argv[2]);
	int R = atoi(argv[3]);
	int dR = atoi(argv[4]);
	int thresh = atoi(argv[5]);
	int channel = 3;
	if (argc > 7)
		channel = atoi(argv[7]);

	char *infilename = argv[6];
	char outfilename[256];

	bool setDebug=!strcmp("debug.tif",infilename);

	if (setDebug) {
		cout << "Using DEBUG mode!!" << endl;
	}

	if (setDebug) {
		cout << "Using DEBUG mode!! - 0-A" << endl;
	} 

	Image rgbimg;

	if (setDebug) {
		cout << "Using DEBUG mode!! - 0-B :" << infilename << endl;
	}

//	char line[81];
//	puts ("Hit return");
//	cout << "hit return" << endl;
	//fflush(stdout);

//	cin >> line;

	rgbimg.read(infilename);

	if (setDebug) {
		cout << "Using DEBUG mode!! - 0-C" << endl;
	}

	rgbimg.toRGB();


	if (setDebug) {
		cout << "Using DEBUG mode!! - 0-D" << endl;
	}


#ifdef WIN32
	rgbimg.flip();
#endif
   

	if (setDebug) {
		cout << "Using DEBUG mode!! - A" << endl;
	}

	Image img;
	img.create(rgbimg.width(), rgbimg.height(), 1);
	binarygrayscale(rgbimg, img, channel, thresh);

	vector <Coord> pts;
	findCenters(rows, cols, R, dR, img, rgbimg, pts);
	printf("Found %d points\n", pts.size());

	if (setDebug) {
		cout << "Using DEBUG mode!! - B" << endl;
	}


	sprintf(outfilename, "houghout_%s", infilename);
	//sprintf(outfilename, "houghout.tif", infilename);

#ifdef WIN32
	rgbimg.flip();
#endif
   	
	if (setDebug) {
		cout << "Using DEBUG mode!! - C" << endl;
	}


	rgbimg.write(outfilename);

	if (setDebug) {
		cout << "Using DEBUG mode!! - D" << endl;
	}


	if (pts.size() != rows*cols) {
#ifdef WIN32		
		img.write("thresholded.tif");
#else
		img.write("thresholded.rgb");
#endif
		exit(1);
	}


	sprintf(outfilename, "%s_points", infilename);
	FILE *f = fopen(outfilename, "w");
	for (int i = 0; i < pts.size(); i++)
		fprintf(f, "%f %f\n", pts[i].x, rgbimg.height() - 1 - pts[i].y);
	fclose(f);

	if (setDebug) {
		cout << "Using DEBUG mode!! - E" << endl;
	}

//6	while(1);
}
