#!/bin/sh -- # -*- perl -*-
eval 'exec perl5 -w -S $0 ${1+"$@"}'
  if 0;

# radius     : dot radius (inches)
# x/y        : number of columns/rows
# space      : row/column spacing (inches)
# offset_x/y : offset from (0,0) corner of page (inches)

my %opt = ( 'radius'   => 20,
	    'x'        => 15,
	    'y'        => 15,
	    'space'    => 65,
	    'offset_x' => 40,
	    'offset_y' => 40 );

foreach ( 'radius', 'space', 'offset_x', 'offset_y' ) {
  $opt{$_} *= 72.0/25.4;
}

print "%!PS-Adobe-2.0\n";
print "gsave\n";
print "0 setgray\n";

$opt{'offset_x'} += 0.5 * $opt{'space'};
$opt{'offset_y'} += 0.5 * $opt{'space'};

for ( my $j = 0; $j < $opt{'y'}; $j++ ) {
  my $y = $opt{'offset_y'} + $j * $opt{'space'};
  for ( my $i = 0; $i < $opt{'x'}; $i++ ) {
    my $x = $opt{'offset_x'} + $i * $opt{'space'};
    printf( "newpath %f %f %f 0 360 arc fill\n", $x, $y, $opt{'radius'} );
  }
}

print "grestore\n";
print "showpage\n";
